/* Generated automatically by the program `genemit'
from the machine description file `md'.  */

#include "config.h"
#include "system.h"
#include "rtl.h"
#include "tm_p.h"
#include "function.h"
#include "expr.h"
#include "optabs.h"
#include "real.h"
#include "flags.h"
#include "output.h"
#include "insn-config.h"
#include "hard-reg-set.h"
#include "recog.h"
#include "resource.h"
#include "reload.h"
#include "toplev.h"
#include "ggc.h"

#define FAIL return (end_sequence (), _val)
#define DONE return (_val = get_insns (), end_sequence (), _val)

/* ./config/pic30/pic30.md:437 */
rtx
gen_addac_hi (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_PLUS (HImode,
	operand0,
	operand1));
}

/* ./config/pic30/pic30.md:448 */
rtx
gen_addacr_shiftrt_hi (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_PLUS (HImode,
	gen_rtx_ASHIFTRT (HImode,
	operand1,
	operand2),
	operand0));
}

/* ./config/pic30/pic30.md:461 */
rtx
gen_addacr_shiftlt_hi (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_PLUS (HImode,
	gen_rtx_ASHIFT (HImode,
	operand1,
	operand2),
	operand0));
}

/* ./config/pic30/pic30.md:480 */
rtx
gen_addacr_noshift_hi (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_PLUS (HImode,
	operand1,
	operand0));
}

/* ./config/pic30/pic30.md:492 */
rtx
gen_addacr1_noshift_hi (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_PLUS (HImode,
	operand0,
	operand1));
}

/* ./config/pic30/pic30.md:504 */
rtx
gen_addacr_shiftrt1_hi (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_PLUS (HImode,
	operand0,
	gen_rtx_ASHIFTRT (HImode,
	operand1,
	operand2)));
}

/* ./config/pic30/pic30.md:517 */
rtx
gen_addacr_shiftlt1_hi (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_PLUS (HImode,
	gen_rtx_ASHIFT (HImode,
	operand1,
	operand2),
	operand0));
}

/* ./config/pic30/pic30.md:536 */
rtx
gen_clrac_gen_hi (operand0, operand1, operand2, operand3, operand4, operand5, operand6, operand7, operand8)
     rtx operand0;
     rtx operand1;
     rtx operand2;
     rtx operand3;
     rtx operand4;
     rtx operand5;
     rtx operand6;
     rtx operand7;
     rtx operand8;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (5,
		gen_rtx_SET (VOIDmode,
	operand0,
	const0_rtx),
		gen_rtx_SET (VOIDmode,
	operand1,
	gen_rtx_MEM (HImode,
	operand2)),
		gen_rtx_SET (VOIDmode,
	operand3,
	gen_rtx_PLUS (HImode,
	operand3,
	operand4)),
		gen_rtx_SET (VOIDmode,
	operand5,
	gen_rtx_MEM (HImode,
	operand6)),
		gen_rtx_SET (VOIDmode,
	operand7,
	gen_rtx_PLUS (HImode,
	operand7,
	operand8))));
}

/* ./config/pic30/pic30.md:570 */
rtx
gen_clracawb_gen_hi (operand0, operand1, operand2, operand3, operand4, operand5, operand6, operand7, operand8, operand9, operand10)
     rtx operand0;
     rtx operand1;
     rtx operand2;
     rtx operand3;
     rtx operand4;
     rtx operand5;
     rtx operand6;
     rtx operand7;
     rtx operand8;
     rtx operand9;
     rtx operand10;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (6,
		gen_rtx_SET (VOIDmode,
	operand0,
	const0_rtx),
		gen_rtx_SET (VOIDmode,
	operand1,
	gen_rtx_MEM (HImode,
	operand2)),
		gen_rtx_SET (VOIDmode,
	operand3,
	gen_rtx_PLUS (HImode,
	operand3,
	operand4)),
		gen_rtx_SET (VOIDmode,
	operand5,
	gen_rtx_MEM (HImode,
	operand6)),
		gen_rtx_SET (VOIDmode,
	operand7,
	gen_rtx_PLUS (HImode,
	operand7,
	operand8)),
		gen_rtx_SET (VOIDmode,
	operand9,
	operand10)));
}

/* ./config/pic30/pic30.md:606 */
rtx
gen_ed_hi (operand0, operand1, operand2, operand3, operand4, operand5, operand6, operand7, operand8)
     rtx operand0;
     rtx operand1;
     rtx operand2;
     rtx operand3;
     rtx operand4;
     rtx operand5;
     rtx operand6;
     rtx operand7;
     rtx operand8;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (4,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MULT (HImode,
	operand1,
	operand1)),
		gen_rtx_SET (VOIDmode,
	operand2,
	gen_rtx_MINUS (HImode,
	gen_rtx_MEM (HImode,
	operand3),
	gen_rtx_MEM (HImode,
	operand4))),
		gen_rtx_SET (VOIDmode,
	operand5,
	gen_rtx_PLUS (HImode,
	operand5,
	operand6)),
		gen_rtx_SET (VOIDmode,
	operand7,
	gen_rtx_PLUS (HImode,
	operand7,
	operand8))));
}

/* ./config/pic30/pic30.md:636 */
rtx
gen_edac_hi (operand0, operand1, operand2, operand3, operand4, operand5, operand6, operand7, operand8)
     rtx operand0;
     rtx operand1;
     rtx operand2;
     rtx operand3;
     rtx operand4;
     rtx operand5;
     rtx operand6;
     rtx operand7;
     rtx operand8;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (4,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_PLUS (HImode,
	operand0,
	gen_rtx_MULT (HImode,
	operand1,
	operand1))),
		gen_rtx_SET (VOIDmode,
	operand2,
	gen_rtx_MINUS (HImode,
	gen_rtx_MEM (HImode,
	operand3),
	gen_rtx_MEM (HImode,
	operand4))),
		gen_rtx_SET (VOIDmode,
	operand5,
	gen_rtx_PLUS (HImode,
	operand5,
	operand6)),
		gen_rtx_SET (VOIDmode,
	operand7,
	gen_rtx_PLUS (HImode,
	operand7,
	operand8))));
}

/* ./config/pic30/pic30.md:668 */
rtx
gen_fbcl_hi (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		operand1),
	21));
}

/* ./config/pic30/pic30.md:682 */
rtx
gen_lac_hi (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (2,
		operand1,
		operand2),
	19));
}

/* ./config/pic30/pic30.md:698 */
rtx
gen_sac_gen_hi (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (2,
		operand1,
		operand2),
	19));
}

/* ./config/pic30/pic30.md:713 */
rtx
gen_sacr_gen_hi (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (2,
		operand1,
		operand2),
	20));
}

/* ./config/pic30/pic30.md:728 */
rtx
gen_mac_gen_hi (operand0, operand1, operand2, operand3, operand4, operand5, operand6, operand7, operand8, operand9, operand10)
     rtx operand0;
     rtx operand1;
     rtx operand2;
     rtx operand3;
     rtx operand4;
     rtx operand5;
     rtx operand6;
     rtx operand7;
     rtx operand8;
     rtx operand9;
     rtx operand10;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (5,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_PLUS (HImode,
	operand0,
	gen_rtx_MULT (HImode,
	operand1,
	operand2))),
		gen_rtx_SET (VOIDmode,
	operand3,
	gen_rtx_MEM (HImode,
	operand4)),
		gen_rtx_SET (VOIDmode,
	operand5,
	gen_rtx_PLUS (HImode,
	operand5,
	operand6)),
		gen_rtx_SET (VOIDmode,
	operand7,
	gen_rtx_MEM (HImode,
	operand8)),
		gen_rtx_SET (VOIDmode,
	operand9,
	gen_rtx_PLUS (HImode,
	operand9,
	operand10))));
}

/* ./config/pic30/pic30.md:791 */
rtx
gen_macawb_gen_hi (operand0, operand1, operand2, operand3, operand4, operand5, operand6, operand7, operand8, operand9, operand10, operand11, operand12)
     rtx operand0;
     rtx operand1;
     rtx operand2;
     rtx operand3;
     rtx operand4;
     rtx operand5;
     rtx operand6;
     rtx operand7;
     rtx operand8;
     rtx operand9;
     rtx operand10;
     rtx operand11;
     rtx operand12;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (6,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_PLUS (HImode,
	operand0,
	gen_rtx_MULT (HImode,
	operand1,
	operand2))),
		gen_rtx_SET (VOIDmode,
	operand3,
	gen_rtx_MEM (HImode,
	operand4)),
		gen_rtx_SET (VOIDmode,
	operand5,
	gen_rtx_PLUS (HImode,
	operand5,
	operand6)),
		gen_rtx_SET (VOIDmode,
	operand7,
	gen_rtx_MEM (HImode,
	operand8)),
		gen_rtx_SET (VOIDmode,
	operand9,
	gen_rtx_PLUS (HImode,
	operand9,
	operand10)),
		gen_rtx_SET (VOIDmode,
	operand11,
	operand12)));
}

/* ./config/pic30/pic30.md:856 */
rtx
gen_movsac_gen_hi (operand0, operand1, operand2, operand3, operand4, operand5, operand6, operand7, operand8)
     rtx operand0;
     rtx operand1;
     rtx operand2;
     rtx operand3;
     rtx operand4;
     rtx operand5;
     rtx operand6;
     rtx operand7;
     rtx operand8;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (5,
		gen_rtx_SET (VOIDmode,
	operand0,
	operand0),
		gen_rtx_SET (VOIDmode,
	operand1,
	gen_rtx_MEM (HImode,
	operand2)),
		gen_rtx_SET (VOIDmode,
	operand3,
	gen_rtx_PLUS (HImode,
	operand3,
	operand4)),
		gen_rtx_SET (VOIDmode,
	operand5,
	gen_rtx_MEM (HImode,
	operand6)),
		gen_rtx_SET (VOIDmode,
	operand7,
	gen_rtx_PLUS (HImode,
	operand7,
	operand8))));
}

/* ./config/pic30/pic30.md:890 */
rtx
gen_movsacawb_gen_hi (operand0, operand1, operand2, operand3, operand4, operand5, operand6, operand7, operand8, operand9, operand10)
     rtx operand0;
     rtx operand1;
     rtx operand2;
     rtx operand3;
     rtx operand4;
     rtx operand5;
     rtx operand6;
     rtx operand7;
     rtx operand8;
     rtx operand9;
     rtx operand10;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (6,
		gen_rtx_SET (VOIDmode,
	operand0,
	operand0),
		gen_rtx_SET (VOIDmode,
	operand1,
	gen_rtx_MEM (HImode,
	operand2)),
		gen_rtx_SET (VOIDmode,
	operand3,
	gen_rtx_PLUS (HImode,
	operand3,
	operand4)),
		gen_rtx_SET (VOIDmode,
	operand5,
	gen_rtx_MEM (HImode,
	operand6)),
		gen_rtx_SET (VOIDmode,
	operand7,
	gen_rtx_PLUS (HImode,
	operand7,
	operand8)),
		gen_rtx_SET (VOIDmode,
	operand9,
	operand10)));
}

/* ./config/pic30/pic30.md:926 */
rtx
gen_mpy_gen_hi (operand0, operand1, operand2, operand3, operand4, operand5, operand6, operand7, operand8, operand9, operand10)
     rtx operand0;
     rtx operand1;
     rtx operand2;
     rtx operand3;
     rtx operand4;
     rtx operand5;
     rtx operand6;
     rtx operand7;
     rtx operand8;
     rtx operand9;
     rtx operand10;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (5,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MULT (HImode,
	operand1,
	operand2)),
		gen_rtx_SET (VOIDmode,
	operand3,
	gen_rtx_MEM (HImode,
	operand4)),
		gen_rtx_SET (VOIDmode,
	operand5,
	gen_rtx_PLUS (HImode,
	operand5,
	operand6)),
		gen_rtx_SET (VOIDmode,
	operand7,
	gen_rtx_MEM (HImode,
	operand8)),
		gen_rtx_SET (VOIDmode,
	operand9,
	gen_rtx_PLUS (HImode,
	operand9,
	operand10))));
}

/* ./config/pic30/pic30.md:981 */
rtx
gen_mpyn_gen_hi (operand0, operand1, operand2, operand3, operand4, operand5, operand6, operand7, operand8, operand9, operand10)
     rtx operand0;
     rtx operand1;
     rtx operand2;
     rtx operand3;
     rtx operand4;
     rtx operand5;
     rtx operand6;
     rtx operand7;
     rtx operand8;
     rtx operand9;
     rtx operand10;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (5,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MULT (HImode,
	gen_rtx_NEG (HImode,
	operand1),
	operand2)),
		gen_rtx_SET (VOIDmode,
	operand3,
	gen_rtx_MEM (HImode,
	operand4)),
		gen_rtx_SET (VOIDmode,
	operand5,
	gen_rtx_PLUS (HImode,
	operand5,
	operand6)),
		gen_rtx_SET (VOIDmode,
	operand7,
	gen_rtx_MEM (HImode,
	operand8)),
		gen_rtx_SET (VOIDmode,
	operand9,
	gen_rtx_PLUS (HImode,
	operand9,
	operand10))));
}

/* ./config/pic30/pic30.md:1037 */
rtx
gen_msc_gen_hi (operand0, operand1, operand2, operand3, operand4, operand5, operand6, operand7, operand8, operand9, operand10)
     rtx operand0;
     rtx operand1;
     rtx operand2;
     rtx operand3;
     rtx operand4;
     rtx operand5;
     rtx operand6;
     rtx operand7;
     rtx operand8;
     rtx operand9;
     rtx operand10;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (5,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MINUS (HImode,
	operand0,
	gen_rtx_MULT (HImode,
	operand1,
	operand2))),
		gen_rtx_SET (VOIDmode,
	operand3,
	gen_rtx_MEM (HImode,
	operand4)),
		gen_rtx_SET (VOIDmode,
	operand5,
	gen_rtx_PLUS (HImode,
	operand5,
	operand6)),
		gen_rtx_SET (VOIDmode,
	operand7,
	gen_rtx_MEM (HImode,
	operand8)),
		gen_rtx_SET (VOIDmode,
	operand9,
	gen_rtx_PLUS (HImode,
	operand9,
	operand10))));
}

/* ./config/pic30/pic30.md:1099 */
rtx
gen_mscawb_gen_hi (operand0, operand1, operand2, operand3, operand4, operand5, operand6, operand7, operand8, operand9, operand10, operand11, operand12)
     rtx operand0;
     rtx operand1;
     rtx operand2;
     rtx operand3;
     rtx operand4;
     rtx operand5;
     rtx operand6;
     rtx operand7;
     rtx operand8;
     rtx operand9;
     rtx operand10;
     rtx operand11;
     rtx operand12;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (6,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MINUS (HImode,
	operand0,
	gen_rtx_MULT (HImode,
	operand1,
	operand2))),
		gen_rtx_SET (VOIDmode,
	operand3,
	gen_rtx_MEM (HImode,
	operand4)),
		gen_rtx_SET (VOIDmode,
	operand5,
	gen_rtx_PLUS (HImode,
	operand5,
	operand6)),
		gen_rtx_SET (VOIDmode,
	operand7,
	gen_rtx_MEM (HImode,
	operand8)),
		gen_rtx_SET (VOIDmode,
	operand9,
	gen_rtx_PLUS (HImode,
	operand9,
	operand10)),
		gen_rtx_SET (VOIDmode,
	operand11,
	operand12)));
}

/* ./config/pic30/pic30.md:1164 */
rtx
gen_sftac_gen_hi (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (2,
		operand0,
		operand1),
	23));
}

/* ./config/pic30/pic30.md:1180 */
rtx
gen_subac_hi (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MINUS (HImode,
	operand0,
	operand1));
}

/* ./config/pic30/pic30.md:1193 */
rtx
gen_movhi_accumulator (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	operand1);
}

/* ./config/pic30/pic30.md:1208 */
rtx
gen_movhi_accumulator2 (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	operand1);
}

/* ./config/pic30/pic30.md:1223 */
rtx
gen_movhi_accumulator3 (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	operand1);
}

/* ./config/pic30/pic30.md:1244 */
rtx
gen_auto_mac (operand0, operand1, operand2, operand3)
     rtx operand0;
     rtx operand1;
     rtx operand2;
     rtx operand3;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_PLUS (HImode,
	operand1,
	gen_rtx_SUBREG (HImode,
	gen_rtx_MULT (SImode,
	gen_rtx_SIGN_EXTEND (SImode,
	operand2),
	gen_rtx_SIGN_EXTEND (SImode,
	operand3)),
	0)));
}

/* ./config/pic30/pic30.md:1270 */
rtx
gen_auto_mac1 (operand0, operand1, operand2, operand3)
     rtx operand0;
     rtx operand1;
     rtx operand2;
     rtx operand3;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_PLUS (HImode,
	gen_rtx_SUBREG (HImode,
	gen_rtx_MULT (SImode,
	gen_rtx_SIGN_EXTEND (SImode,
	operand1),
	gen_rtx_SIGN_EXTEND (SImode,
	operand2)),
	0),
	operand3));
}

/* ./config/pic30/pic30.md:1296 */
rtx
gen_auto_mpy (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_NEG (HImode,
	gen_rtx_SUBREG (HImode,
	gen_rtx_MULT (SImode,
	gen_rtx_SIGN_EXTEND (SImode,
	operand1),
	gen_rtx_SIGN_EXTEND (SImode,
	operand2)),
	0)));
}

/* ./config/pic30/pic30.md:1321 */
rtx
gen_auto_msc (operand0, operand1, operand2, operand3)
     rtx operand0;
     rtx operand1;
     rtx operand2;
     rtx operand3;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MINUS (HImode,
	operand1,
	gen_rtx_SUBREG (HImode,
	gen_rtx_MULT (SImode,
	gen_rtx_SIGN_EXTEND (SImode,
	operand2),
	gen_rtx_SIGN_EXTEND (SImode,
	operand3)),
	0)));
}

/* ./config/pic30/pic30.md:1347 */
rtx
gen_auto_msc1 (operand0, operand1, operand2, operand3)
     rtx operand0;
     rtx operand1;
     rtx operand2;
     rtx operand3;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MINUS (HImode,
	gen_rtx_SUBREG (HImode,
	gen_rtx_MULT (SImode,
	gen_rtx_SIGN_EXTEND (SImode,
	operand1),
	gen_rtx_SIGN_EXTEND (SImode,
	operand2)),
	0),
	operand3));
}

/* ./config/pic30/pic30.md:1373 */
rtx
gen_auto_sftacr (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFTRT (HImode,
	operand0,
	operand1));
}

/* ./config/pic30/pic30.md:1392 */
rtx
gen_auto_sftacl (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFT (HImode,
	operand0,
	operand1));
}

/* ./config/pic30/pic30.md:1411 */
rtx
gen_addacr_hi (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_PLUS (HImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:1430 */
rtx
gen_addacr1_hi (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_PLUS (HImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:1475 */
rtx
gen_pushhi (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	operand1);
}

/* ./config/pic30/pic30.md:1490 */
rtx
gen_pushsi (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	operand1);
}

/* ./config/pic30/pic30.md:1534 */
rtx
gen_pushshadow ()
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (5,
		gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (1,
		const0_rtx),
	2),
		gen_rtx_USE (VOIDmode,
	gen_rtx_REG (HImode,
	0)),
		gen_rtx_USE (VOIDmode,
	gen_rtx_REG (HImode,
	1)),
		gen_rtx_USE (VOIDmode,
	gen_rtx_REG (HImode,
	2)),
		gen_rtx_USE (VOIDmode,
	gen_rtx_REG (HImode,
	3))));
}

/* ./config/pic30/pic30.md:1544 */
rtx
gen_popshadow ()
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (5,
		gen_rtx_UNSPEC (VOIDmode,
	gen_rtvec (1,
		const0_rtx),
	3),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_REG (HImode,
	0)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_REG (HImode,
	1)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_REG (HImode,
	2)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_REG (HImode,
	3))));
}

/* ./config/pic30/pic30.md:1560 */
rtx
gen_popqi (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	operand1);
}

/* ./config/pic30/pic30.md:1571 */
rtx
gen_pophi (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	operand1);
}

/* ./config/pic30/pic30.md:1586 */
rtx
gen_pophi_unspec (operand0)
     rtx operand0;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		operand0),
	1),
	gen_rtx_MEM (HImode,
	gen_rtx_PRE_DEC (HImode,
	gen_rtx_REG (HImode,
	15)))),
		gen_rtx_CLOBBER (VOIDmode,
	operand0)));
}

/* ./config/pic30/pic30.md:1602 */
rtx
gen_popsi (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	operand1);
}

/* ./config/pic30/pic30.md:1614 */
rtx
gen_popdi (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	operand1);
}

/* ./config/pic30/pic30.md:1625 */
rtx
gen_popsf (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	operand1);
}

/* ./config/pic30/pic30.md:1636 */
rtx
gen_popdf (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	operand1);
}

/* ./config/pic30/pic30.md:1664 */
rtx
gen_tstqi (operand0)
     rtx operand0;
{
  return gen_rtx_SET (VOIDmode,
	cc0_rtx,
	operand0);
}

/* ./config/pic30/pic30.md:1682 */
rtx
gen_tsthi (operand0)
     rtx operand0;
{
  return gen_rtx_SET (VOIDmode,
	cc0_rtx,
	operand0);
}

/* ./config/pic30/pic30.md:1700 */
rtx
gen_tstsi (operand0)
     rtx operand0;
{
  return gen_rtx_SET (VOIDmode,
	cc0_rtx,
	operand0);
}

/* ./config/pic30/pic30.md:1707 */
rtx
gen_tstdi (operand0)
     rtx operand0;
{
  return gen_rtx_SET (VOIDmode,
	cc0_rtx,
	operand0);
}

/* ./config/pic30/pic30.md:1882 */
rtx
gen_cmpqi3_sfr0 (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	cc0_rtx,
	gen_rtx_COMPARE (QImode,
	operand0,
	operand1)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode))));
}

/* ./config/pic30/pic30.md:1893 */
rtx
gen_cmpqi3_2sfr (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	cc0_rtx,
	gen_rtx_COMPARE (QImode,
	operand0,
	operand1)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode))));
}

/* ./config/pic30/pic30.md:1955 */
rtx
gen_cmpqi_normal (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	cc0_rtx,
	gen_rtx_COMPARE (VOIDmode,
	operand0,
	operand1));
}

/* ./config/pic30/pic30.md:1996 */
rtx
gen_cmphi (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	cc0_rtx,
	gen_rtx_COMPARE (VOIDmode,
	operand0,
	operand1));
}

/* ./config/pic30/pic30.md:2021 */
rtx
gen_cmpsi (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	cc0_rtx,
	gen_rtx_COMPARE (VOIDmode,
	operand0,
	operand1));
}

/* ./config/pic30/pic30.md:2092 */
rtx
gen_cmpdi (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	cc0_rtx,
	gen_rtx_COMPARE (VOIDmode,
	operand0,
	operand1));
}

/* ./config/pic30/pic30.md:2110 */
rtx
gen_zero_extendqihi2 (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ZERO_EXTEND (HImode,
	operand1));
}

/* ./config/pic30/pic30.md:2121 */
rtx
gen_zero_extendqisi2 (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ZERO_EXTEND (SImode,
	operand1));
}

/* ./config/pic30/pic30.md:2136 */
rtx
gen_zero_extendqidi2 (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ZERO_EXTEND (DImode,
	operand1));
}

/* ./config/pic30/pic30.md:2153 */
rtx
gen_zero_extendhisi2 (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ZERO_EXTEND (SImode,
	operand1));
}

/* ./config/pic30/pic30.md:2181 */
rtx
gen_zero_extendhidi2 (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ZERO_EXTEND (DImode,
	operand1));
}

/* ./config/pic30/pic30.md:2211 */
rtx
gen_extendqihi2 (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_SIGN_EXTEND (HImode,
	operand1));
}

/* ./config/pic30/pic30.md:2224 */
rtx
gen_extendqisi2 (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_SIGN_EXTEND (SImode,
	operand1));
}

/* ./config/pic30/pic30.md:2239 */
rtx
gen_extendqidi2 (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_SIGN_EXTEND (DImode,
	operand1));
}

/* ./config/pic30/pic30.md:2256 */
rtx
gen_extendhisi2 (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_SIGN_EXTEND (SImode,
	operand1));
}

/* ./config/pic30/pic30.md:2285 */
rtx
gen_extendhidi2 (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_SIGN_EXTEND (DImode,
	operand1));
}

/* ./config/pic30/pic30.md:2386 */
rtx
gen_movqi_rimm (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	operand1);
}

/* ./config/pic30/pic30.md:2434 */
rtx
gen_movqi_gen_a (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	operand1);
}

/* ./config/pic30/pic30.md:2470 */
rtx
gen_movqi_gen_b (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	operand1);
}

/* ./config/pic30/pic30.md:2505 */
rtx
gen_movqi_sfr_a (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	operand1);
}

/* ./config/pic30/pic30.md:2538 */
rtx
gen_movqi_sfr_b (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	operand1);
}

/* ./config/pic30/pic30.md:2702 */
rtx
gen_movhi_address (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	operand1);
}

/* ./config/pic30/pic30.md:2723 */
rtx
gen_movhi_imm (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	operand1);
}

/* ./config/pic30/pic30.md:2738 */
rtx
gen_readsfr (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_UNSPEC_VOLATILE (HImode,
	gen_rtvec (1,
		operand1),
	15));
}

/* ./config/pic30/pic30.md:2746 */
rtx
gen_writesfr (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_UNSPEC_VOLATILE (HImode,
	gen_rtvec (2,
		operand0,
		operand1),
	17);
}

/* ./config/pic30/pic30.md:2755 */
rtx
gen_tblpage (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		operand1),
	5));
}

/* ./config/pic30/pic30.md:2763 */
rtx
gen_tbloffset (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		operand1),
	6));
}

/* ./config/pic30/pic30.md:2771 */
rtx
gen_psvpage (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		operand1),
	7));
}

/* ./config/pic30/pic30.md:2779 */
rtx
gen_psvoffset (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		operand1),
	8));
}

/* ./config/pic30/pic30.md:2787 */
rtx
gen_dmaoffset (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (1,
		operand1),
	18));
}

/* ./config/pic30/pic30.md:2799 */
rtx
gen_movhi_gen (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	operand1);
}

/* ./config/pic30/pic30.md:2848 */
rtx
gen_movhi_reload_lo (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_SUBREG (HImode,
	operand1,
	0));
}

/* ./config/pic30/pic30.md:2867 */
rtx
gen_movhi_reload_hi (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_SUBREG (HImode,
	operand1,
	2));
}

/* ./config/pic30/pic30.md:2961 */
rtx
gen_movsi_address (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	operand1);
}

/* ./config/pic30/pic30.md:2972 */
rtx
gen_movsi_rimm (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	operand1);
}

/* ./config/pic30/pic30.md:2985 */
rtx
gen_movsi_gen (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	operand1);
}

/* ./config/pic30/pic30.md:3384 */
rtx
gen_movsf_general (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	operand1);
}

/* ./config/pic30/pic30.md:3579 */
rtx
gen_movdf_gen (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	operand1);
}

/* ./config/pic30/pic30.md:3848 */
rtx
gen_addqi3 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_PLUS (QImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:3963 */
rtx
gen_addhi3 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_PLUS (HImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:4189 */
rtx
gen_addsi3 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_PLUS (SImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:4283 */
rtx
gen_adddi3 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_PLUS (DImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:4321 */
rtx
gen_subqi3 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MINUS (QImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:4386 */
rtx
gen_subhi3 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MINUS (HImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:4414 */
rtx
gen_subhi3_sfr0 (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MINUS (HImode,
	operand0,
	operand1));
}

/* ./config/pic30/pic30.md:4510 */
rtx
gen_subsi3 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MINUS (SImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:4565 */
rtx
gen_subdi3 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MINUS (DImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:4618 */
rtx
gen_umulqihi3gen (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MULT (HImode,
	gen_rtx_ZERO_EXTEND (HImode,
	operand1),
	gen_rtx_ZERO_EXTEND (HImode,
	operand2)));
}

/* ./config/pic30/pic30.md:4635 */
rtx
gen_umulqihi3imm (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MULT (HImode,
	gen_rtx_ZERO_EXTEND (HImode,
	operand1),
	operand2));
}

/* ./config/pic30/pic30.md:4649 */
rtx
gen_umulqihi3pow2 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MULT (HImode,
	gen_rtx_ZERO_EXTEND (HImode,
	operand1),
	operand2));
}

/* ./config/pic30/pic30.md:4686 */
rtx
gen_mulhi3imm (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MULT (HImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:4722 */
rtx
gen_umulhisi3 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MULT (SImode,
	gen_rtx_ZERO_EXTEND (SImode,
	operand1),
	gen_rtx_ZERO_EXTEND (SImode,
	operand2)));
}

/* ./config/pic30/pic30.md:4759 */
rtx
gen_mulhisi3_imm (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MULT (SImode,
	gen_rtx_SIGN_EXTEND (SImode,
	operand1),
	operand2));
}

/* ./config/pic30/pic30.md:4771 */
rtx
gen_mulhisi3 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MULT (SImode,
	gen_rtx_SIGN_EXTEND (SImode,
	operand1),
	gen_rtx_SIGN_EXTEND (SImode,
	operand2)));
}

/* ./config/pic30/pic30.md:4788 */
rtx
gen_mulsu (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (2,
		operand1,
		operand2),
	12));
}

/* ./config/pic30/pic30.md:4807 */
rtx
gen_muluu (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (2,
		operand1,
		operand2),
	14));
}

/* ./config/pic30/pic30.md:4826 */
rtx
gen_mulus (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (2,
		operand1,
		operand2),
	13));
}

/* ./config/pic30/pic30.md:4842 */
rtx
gen_mulss (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_UNSPEC (SImode,
	gen_rtvec (2,
		operand1,
		operand2),
	11));
}

/* ./config/pic30/pic30.md:4914 */
rtx
gen_divsd (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (2,
		operand1,
		operand2),
	9)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_REG (HImode,
	16))));
}

/* ./config/pic30/pic30.md:4988 */
rtx
gen_divud (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_UNSPEC (HImode,
	gen_rtvec (2,
		operand1,
		operand2),
	10)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_REG (HImode,
	16))));
}

/* ./config/pic30/pic30.md:5063 */
rtx
gen_divmodhi4 (operand0, operand1, operand2, operand3)
     rtx operand0;
     rtx operand1;
     rtx operand2;
     rtx operand3;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (3,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_DIV (HImode,
	operand1,
	operand2)),
		gen_rtx_SET (VOIDmode,
	operand3,
	gen_rtx_MOD (HImode,
	operand1,
	operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_REG (HImode,
	16))));
}

/* ./config/pic30/pic30.md:5219 */
rtx
gen_divmodhi4_w0 (operand0, operand1, operand2, operand3)
     rtx operand0;
     rtx operand1;
     rtx operand2;
     rtx operand3;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (3,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_DIV (HImode,
	operand1,
	operand2)),
		gen_rtx_SET (VOIDmode,
	operand3,
	gen_rtx_MOD (HImode,
	operand1,
	operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_REG (HImode,
	16))));
}

/* ./config/pic30/pic30.md:5240 */
rtx
gen_divmodhi4_w1 (operand0, operand1, operand2, operand3)
     rtx operand0;
     rtx operand1;
     rtx operand2;
     rtx operand3;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (3,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_DIV (HImode,
	operand1,
	operand2)),
		gen_rtx_SET (VOIDmode,
	operand3,
	gen_rtx_MOD (HImode,
	operand1,
	operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_REG (HImode,
	16))));
}

/* ./config/pic30/pic30.md:5262 */
rtx
gen_udivmodhi4 (operand0, operand1, operand2, operand3)
     rtx operand0;
     rtx operand1;
     rtx operand2;
     rtx operand3;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (3,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_UDIV (HImode,
	operand1,
	operand2)),
		gen_rtx_SET (VOIDmode,
	operand3,
	gen_rtx_UMOD (HImode,
	operand1,
	operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_REG (HImode,
	16))));
}

/* ./config/pic30/pic30.md:5418 */
rtx
gen_udivmodhi4_w0 (operand0, operand1, operand2, operand3)
     rtx operand0;
     rtx operand1;
     rtx operand2;
     rtx operand3;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (3,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_DIV (HImode,
	operand1,
	operand2)),
		gen_rtx_SET (VOIDmode,
	operand3,
	gen_rtx_MOD (HImode,
	operand1,
	operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_REG (HImode,
	16))));
}

/* ./config/pic30/pic30.md:5439 */
rtx
gen_udivmodhi4_w1 (operand0, operand1, operand2, operand3)
     rtx operand0;
     rtx operand1;
     rtx operand2;
     rtx operand3;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (3,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_DIV (HImode,
	operand1,
	operand2)),
		gen_rtx_SET (VOIDmode,
	operand3,
	gen_rtx_MOD (HImode,
	operand1,
	operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_REG (HImode,
	16))));
}

/* ./config/pic30/pic30.md:5488 */
rtx
gen_abssf2 (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ABS (SFmode,
	operand1));
}

/* ./config/pic30/pic30.md:5503 */
rtx
gen_absdf2 (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ABS (DFmode,
	operand1));
}

/* ./config/pic30/pic30.md:5522 */
rtx
gen_negqi2 (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_NEG (QImode,
	operand1));
}

/* ./config/pic30/pic30.md:5555 */
rtx
gen_neghi2 (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_NEG (HImode,
	operand1));
}

/* ./config/pic30/pic30.md:5591 */
rtx
gen_negsi2 (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_NEG (SImode,
	operand1));
}

/* ./config/pic30/pic30.md:5606 */
rtx
gen_negsf2 (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_NEG (SFmode,
	operand1));
}

/* ./config/pic30/pic30.md:5628 */
rtx
gen_negdf2 (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_NEG (DFmode,
	operand1));
}

/* ./config/pic30/pic30.md:5651 */
rtx
gen_bitsetqi (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_IOR (QImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:5662 */
rtx
gen_bitsetqi_sfr (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_IOR (QImode,
	operand0,
	operand1));
}

/* ./config/pic30/pic30.md:5673 */
rtx
gen_bitclrqi (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_AND (QImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:5684 */
rtx
gen_bitclrqi_sfr (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_AND (QImode,
	operand0,
	operand1));
}

/* ./config/pic30/pic30.md:5696 */
rtx
gen_bittogqi (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_XOR (QImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:5707 */
rtx
gen_bittogqi_sfr (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_XOR (QImode,
	operand0,
	operand1));
}

/* ./config/pic30/pic30.md:5751 */
rtx
gen_bitsethi (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_IOR (HImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:5782 */
rtx
gen_bitclrhi (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_AND (HImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:5814 */
rtx
gen_bittoghi (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_XOR (HImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:5825 */
rtx
gen_bittoghi_sfr (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_XOR (HImode,
	operand0,
	operand1));
}

/* ./config/pic30/pic30.md:6005 */
rtx
gen_bittogsi (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_XOR (SImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:6023 */
rtx
gen_bittogsi_sfr (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_XOR (SImode,
	operand0,
	operand1));
}

/* ./config/pic30/pic30.md:6130 */
rtx
gen_andqi3 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_AND (QImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:6210 */
rtx
gen_andhi3 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_AND (HImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:6302 */
rtx
gen_andsi3 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_AND (SImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:6374 */
rtx
gen_anddi3 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_AND (DImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:6406 */
rtx
gen_iorqi3 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_IOR (QImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:6480 */
rtx
gen_iorhi3_sfr0 (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_IOR (HImode,
	operand1,
	operand0)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode))));
}

/* ./config/pic30/pic30.md:6491 */
rtx
gen_iorhi3_sfr0a (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_IOR (HImode,
	operand0,
	operand1));
}

/* ./config/pic30/pic30.md:6557 */
rtx
gen_iorhi3 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_IOR (HImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:6587 */
rtx
gen_iorsi3 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_IOR (SImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:6634 */
rtx
gen_iordi3 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_IOR (DImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:6666 */
rtx
gen_xorqi3 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_XOR (QImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:6739 */
rtx
gen_xorhi3 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_XOR (HImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:6764 */
rtx
gen_xorhi3_sfr2 (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_XOR (HImode,
	operand0,
	operand1));
}

/* ./config/pic30/pic30.md:6791 */
rtx
gen_xorhi3_sfr3 (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_XOR (HImode,
	operand1,
	operand0));
}

/* ./config/pic30/pic30.md:6862 */
rtx
gen_xorsi3 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_XOR (SImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:6890 */
rtx
gen_xordi3 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_XOR (DImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:6910 */
rtx
gen_one_cmplqi2 (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_NOT (QImode,
	operand1));
}

/* ./config/pic30/pic30.md:6932 */
rtx
gen_one_cmplhi2 (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_NOT (HImode,
	operand1));
}

/* ./config/pic30/pic30.md:6954 */
rtx
gen_one_cmplsi2 (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_NOT (SImode,
	operand1));
}

/* ./config/pic30/pic30.md:6981 */
rtx
gen_ffshi2 (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_FFS (HImode,
	operand1));
}

/* ./config/pic30/pic30.md:7034 */
rtx
gen_ashlqi3 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFT (QImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:7107 */
rtx
gen_ashlhi3 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFT (HImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:7186 */
rtx
gen_ashlsi3_imm1 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFT (SImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:7198 */
rtx
gen_ashlsi3_imm8 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFT (SImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:7228 */
rtx
gen_ashlsi3_imm16plus (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFT (SImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:7240 */
rtx
gen_ashlsi3_imm2to15 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFT (SImode,
	operand1,
	operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode))));
}

/* ./config/pic30/pic30.md:7289 */
rtx
gen_ashlsi3_reg (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFT (SImode,
	operand1,
	operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode))));
}

/* ./config/pic30/pic30.md:7377 */
rtx
gen_ashldi3_imm1 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFT (DImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:7389 */
rtx
gen_ashldi3_imm16 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFT (DImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:7401 */
rtx
gen_ashldi3_imm32 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFT (DImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:7413 */
rtx
gen_ashldi3_imm48 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFT (DImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:7425 */
rtx
gen_ashldi3_immn (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFT (DImode,
	operand1,
	operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode))));
}

/* ./config/pic30/pic30.md:7452 */
rtx
gen_ashldi3_reg (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFT (DImode,
	operand1,
	operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode))));
}

/* ./config/pic30/pic30.md:7560 */
rtx
gen_lshrhi3 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_LSHIFTRT (HImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:7621 */
rtx
gen_lshrsi3_imm1 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_LSHIFTRT (SImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:7634 */
rtx
gen_lshrsi3_imm16plus (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_LSHIFTRT (SImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:7646 */
rtx
gen_lshrsi3_imm2to15 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_LSHIFTRT (SImode,
	operand1,
	operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode))));
}

/* ./config/pic30/pic30.md:7678 */
rtx
gen_lshrsi3_reg (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_LSHIFTRT (SImode,
	operand1,
	operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode))));
}

/* ./config/pic30/pic30.md:7766 */
rtx
gen_lshrdi3_imm1 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_LSHIFTRT (DImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:7778 */
rtx
gen_lshrdi3_imm16 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_LSHIFTRT (DImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:7790 */
rtx
gen_lshrdi3_imm32 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_LSHIFTRT (DImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:7802 */
rtx
gen_lshrdi3_imm48 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_LSHIFTRT (DImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:7814 */
rtx
gen_lshrdi3_immn (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_LSHIFTRT (DImode,
	operand1,
	operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode))));
}

/* ./config/pic30/pic30.md:7841 */
rtx
gen_lshrdi3_reg (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_LSHIFTRT (DImode,
	operand1,
	operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode))));
}

/* ./config/pic30/pic30.md:7933 */
rtx
gen_ashrhi3 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFTRT (HImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:8004 */
rtx
gen_ashrsi3_imm1 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFTRT (SImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:8017 */
rtx
gen_ashrsi3_imm2to15 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFTRT (SImode,
	operand1,
	operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode))));
}

/* ./config/pic30/pic30.md:8049 */
rtx
gen_ashrsi3_imm16plus (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFTRT (SImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:8061 */
rtx
gen_ashrsi3_reg (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFTRT (SImode,
	operand1,
	operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode))));
}

/* ./config/pic30/pic30.md:8149 */
rtx
gen_ashrdi3_imm1 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFTRT (DImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:8161 */
rtx
gen_ashrdi3_imm16 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFTRT (DImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:8173 */
rtx
gen_ashrdi3_imm32 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFTRT (DImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:8185 */
rtx
gen_ashrdi3_imm48 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFTRT (DImode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:8197 */
rtx
gen_ashrdi3_immn (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFTRT (DImode,
	operand1,
	operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode))));
}

/* ./config/pic30/pic30.md:8224 */
rtx
gen_ashrdi3_reg (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFTRT (DImode,
	operand1,
	operand2)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode))));
}

/* ./config/pic30/pic30.md:8484 */
rtx
gen_beq (operand0)
     rtx operand0;
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_EQ (VOIDmode,
	cc0_rtx,
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand0),
	pc_rtx));
}

/* ./config/pic30/pic30.md:8494 */
rtx
gen_bne (operand0)
     rtx operand0;
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_NE (VOIDmode,
	cc0_rtx,
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand0),
	pc_rtx));
}

/* ./config/pic30/pic30.md:8504 */
rtx
gen_bgt (operand0)
     rtx operand0;
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_GT (VOIDmode,
	cc0_rtx,
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand0),
	pc_rtx));
}

/* ./config/pic30/pic30.md:8514 */
rtx
gen_blt (operand0)
     rtx operand0;
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_LT (VOIDmode,
	cc0_rtx,
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand0),
	pc_rtx));
}

/* ./config/pic30/pic30.md:8524 */
rtx
gen_bge (operand0)
     rtx operand0;
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_GE (VOIDmode,
	cc0_rtx,
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand0),
	pc_rtx));
}

/* ./config/pic30/pic30.md:8534 */
rtx
gen_ble (operand0)
     rtx operand0;
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_LE (VOIDmode,
	cc0_rtx,
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand0),
	pc_rtx));
}

/* ./config/pic30/pic30.md:8547 */
rtx
gen_bgtu (operand0)
     rtx operand0;
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_GTU (VOIDmode,
	cc0_rtx,
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand0),
	pc_rtx));
}

/* ./config/pic30/pic30.md:8557 */
rtx
gen_bltu (operand0)
     rtx operand0;
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_LTU (VOIDmode,
	cc0_rtx,
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand0),
	pc_rtx));
}

/* ./config/pic30/pic30.md:8567 */
rtx
gen_bgeu (operand0)
     rtx operand0;
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_GEU (VOIDmode,
	cc0_rtx,
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand0),
	pc_rtx));
}

/* ./config/pic30/pic30.md:8577 */
rtx
gen_bleu (operand0)
     rtx operand0;
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_IF_THEN_ELSE (VOIDmode,
	gen_rtx_LEU (VOIDmode,
	cc0_rtx,
	const0_rtx),
	gen_rtx_LABEL_REF (VOIDmode,
	operand0),
	pc_rtx));
}

/* ./config/pic30/pic30.md:8611 */
rtx
gen_indirect_jump (operand0)
     rtx operand0;
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	operand0);
}

/* ./config/pic30/pic30.md:8629 */
rtx
gen_tablejump (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	pc_rtx,
	operand0),
		gen_rtx_USE (VOIDmode,
	gen_rtx_LABEL_REF (VOIDmode,
	operand1))));
}

/* ./config/pic30/pic30.md:8669 */
rtx
gen_casesi0 (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_PLUS (SImode,
	gen_rtx_MEM (SImode,
	gen_rtx_PLUS (SImode,
	pc_rtx,
	operand0)),
	gen_rtx_LABEL_REF (VOIDmode,
	operand1))),
		gen_rtx_CLOBBER (VOIDmode,
	operand0)));
}

/* ./config/pic30/pic30.md:8704 */
rtx
gen_jump (operand0)
     rtx operand0;
{
  return gen_rtx_SET (VOIDmode,
	pc_rtx,
	gen_rtx_LABEL_REF (VOIDmode,
	operand0));
}

/* ./config/pic30/pic30.md:8730 */
rtx
gen_call_value_helper (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  return gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_CALL (VOIDmode,
	operand1,
	operand2));
}

/* ./config/pic30/pic30.md:8822 */
rtx
gen_return ()
{
  return gen_rtx_RETURN (VOIDmode);
}

/* ./config/pic30/pic30.md:8833 */
rtx
gen_return_from_epilogue ()
{
  return gen_rtx_RETURN (VOIDmode);
}

/* ./config/pic30/pic30.md:8852 */
rtx
gen_lnk (operand0)
     rtx operand0;
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (4,
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (HImode,
	15),
	operand0),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_REG (HImode,
	14)),
		gen_rtx_USE (VOIDmode,
	gen_rtx_REG (HImode,
	14)),
		gen_rtx_USE (VOIDmode,
	gen_rtx_REG (HImode,
	15))));
}

/* ./config/pic30/pic30.md:8870 */
rtx
gen_ulnk ()
{
  return gen_rtx_PARALLEL (VOIDmode, gen_rtvec (2,
		gen_rtx_SET (VOIDmode,
	gen_rtx_REG (HImode,
	15),
	gen_rtx_REG (HImode,
	14)),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_REG (HImode,
	14))));
}

/* ./config/pic30/pic30.md:8885 */
rtx
gen_disi (operand0)
     rtx operand0;
{
  return gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (1,
		operand0),
	16);
}

/* ./config/pic30/pic30.md:8919 */
rtx
gen_blockage ()
{
  return gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (1,
		const0_rtx),
	0);
}

/* ./config/pic30/pic30.md:8924 */
rtx
gen_pa (operand0)
     rtx operand0;
{
  return gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (1,
		operand0),
	1);
}

/* ./config/pic30/pic30.md:8929 */
rtx
gen_iv (operand0)
     rtx operand0;
{
  return gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (1,
		operand0),
	2);
}

/* ./config/pic30/pic30.md:8952 */
rtx
gen_pp ()
{
  return gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (1,
		const0_rtx),
	3);
}

/* ./config/pic30/pic30.md:8964 */
rtx
gen_bifnop ()
{
  return gen_rtx_UNSPEC_VOLATILE (VOIDmode,
	gen_rtvec (1,
		const0_rtx),
	4);
}

/* ./config/pic30/pic30.md:8970 */
rtx
gen_nop ()
{
  return const0_rtx;
}

/* ./config/pic30/pic30.md:1726 */
rtx
gen_movstrhi (operand0, operand1, operand2, operand3)
     rtx operand0;
     rtx operand1;
     rtx operand2;
     rtx operand3;
{
  rtx operand4;
  rtx operand5;
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[6];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;
    operands[3] = operand3;

{
	rtx addr0;
	rtx addr1;
	int n;

	if (GET_CODE (operands[2]) != CONST_INT)
		FAIL;
	n = INTVAL(operands[2]);
	if (n < 1)
		FAIL;

	switch (INTVAL(operands[3]))
	{
	case 1:
		if (n > 16383)
			FAIL;
		break;
	default:
		if ((n > (16383*2)) || (n & 1))
			FAIL;
	}

	addr0 = copy_to_mode_reg(Pmode, XEXP (operands[0], 0));
	addr1 = copy_to_mode_reg(Pmode, XEXP (operands[1], 0));

	operands[4] = addr0;
	operands[5] = addr1;
	operands[0] = change_address(operands[0], VOIDmode, addr0);
	operands[1] = change_address(operands[1], VOIDmode, addr1);
}
    operand0 = operands[0];
    operand1 = operands[1];
    operand2 = operands[2];
    operand3 = operands[3];
    operand4 = operands[4];
    operand5 = operands[5];
  }
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (6,
		gen_rtx_SET (VOIDmode,
	operand0,
	operand1),
		gen_rtx_USE (VOIDmode,
	operand2),
		gen_rtx_USE (VOIDmode,
	operand3),
		gen_rtx_CLOBBER (VOIDmode,
	operand4),
		gen_rtx_CLOBBER (VOIDmode,
	operand5),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_REG (HImode,
	16)))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:1803 */
rtx
gen_clrstrhi (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  rtx operand3;
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[4];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;

{
	rtx addr0;
	int n;

	if (GET_CODE (operands[1]) != CONST_INT)
		FAIL;
	n = INTVAL(operands[1]);
	if (n < 1)
		FAIL;

	switch (INTVAL(operands[2]))
	{
	case 1:
		if (n > 16383)
			FAIL;
		break;
	default:
		if ((n > (16383/2)) || (n & 1))
			FAIL;
	}
	addr0 = copy_to_mode_reg (Pmode, XEXP (operands[0], 0));

	operands[3] = addr0;

	operands[0] = gen_rtx_MEM (BLKmode, addr0);
}
    operand0 = operands[0];
    operand1 = operands[1];
    operand2 = operands[2];
    operand3 = operands[3];
  }
  emit (gen_rtx_PARALLEL (VOIDmode,
	gen_rtvec (5,
		gen_rtx_SET (VOIDmode,
	operand0,
	const0_rtx),
		gen_rtx_USE (VOIDmode,
	operand1),
		gen_rtx_USE (VOIDmode,
	operand2),
		gen_rtx_CLOBBER (VOIDmode,
	operand3),
		gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_REG (HImode,
	16)))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:1907 */
rtx
gen_cmpqi (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  rtx operand2;
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[3];
    operands[0] = operand0;
    operands[1] = operand1;
{
      if (pic30_near_operand(operands[0],QImode) &&
          pic30_near_operand(operands[1],QImode)) {
  
        rtx pop; 
  
        operands[2] = gen_reg_rtx(QImode);
        
        emit_insn(gen_movqi_gen_b(operands[2],operands[1]));
        emit_insn(gen_cmpqi3_sfr0(operands[0],operands[2]));
      } else if (pic30_near_operand(operands[1],QImode)) {
        if (pic30_wreg_operand(operands[0],QImode))
          emit_insn(gen_cmpqi3_2sfr(operands[0],operands[1]));
        else { 
          rtx pop; 

          operands[2] = gen_reg_rtx(HImode);
          pop = gen_rtx_MEM(QImode, operands[2]);
          emit_insn(gen_movhi_address(operands[2],  XEXP(operands[1],0)));
          emit_insn(gen_cmpqi_normal(operands[0],pop));
        }
      }
      else if (pic30_near_operand(operands[0],QImode)) {
        if (pic30_wreg_operand(operands[1],QImode))
          emit_insn(gen_cmpqi3_sfr0(operands[0],operands[1]));
        else {
          rtx pop;

          operands[2] = gen_reg_rtx(HImode);
          pop = gen_rtx_MEM(QImode, operands[2]);
          emit_insn(gen_movhi_address(operands[2], XEXP(operands[0],0)));
          emit_insn(gen_cmpqi_normal(pop,operands[1]));
        }
      } else {
        emit_insn(gen_cmpqi_normal(operands[0],operands[1]));
      }
      DONE;
   }
  
    operand0 = operands[0];
    operand1 = operands[1];
    operand2 = operands[2];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	cc0_rtx,
	gen_rtx_COMPARE (VOIDmode,
	operand0,
	operand1)));
  emit (operand2);
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:2579 */
rtx
gen_movqi (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[2];
    operands[0] = operand0;
    operands[1] = operand1;

{
	pic30_emit_move_sequence(operands, QImode);
}
    operand0 = operands[0];
    operand1 = operands[1];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	operand1));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:2834 */
rtx
gen_movhi (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[2];
    operands[0] = operand0;
    operands[1] = operand1;

{
	pic30_emit_move_sequence(operands, HImode);
}
    operand0 = operands[0];
    operand1 = operands[1];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	operand1));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:2908 */
rtx
gen_movsi (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[2];
    operands[0] = operand0;
    operands[1] = operand1;

{
	pic30_emit_move_sequence(operands, SImode);
}
    operand0 = operands[0];
    operand1 = operands[1];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	operand1));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:3326 */
rtx
gen_movdi (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[2];
    operands[0] = operand0;
    operands[1] = operand1;

{
	pic30_emit_move_sequence(operands, DImode);
}
    operand0 = operands[0];
    operand1 = operands[1];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	operand1));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:3486 */
rtx
gen_movsf (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[2];
    operands[0] = operand0;
    operands[1] = operand1;

{
	pic30_emit_move_sequence(operands, SFmode);
}
    operand0 = operands[0];
    operand1 = operands[1];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	operand1));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:3562 */
extern rtx gen_split_377 PARAMS ((rtx *));
rtx
gen_split_377 (operands)
      rtx *operands;
{
  rtx operand0;
  rtx operand1;
  rtx _val = 0;
  start_sequence ();

  operand0 = operands[0];
  operand1 = operands[1];
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_SUBREG (SImode,
	operand0,
	0),
	gen_rtx_SUBREG (SImode,
	operand1,
	0)));
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_SUBREG (SImode,
	copy_rtx (operand0),
	4),
	gen_rtx_SUBREG (SImode,
	copy_rtx (operand1),
	4)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:3745 */
rtx
gen_movdf (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[2];
    operands[0] = operand0;
    operands[1] = operand1;

{
	pic30_emit_move_sequence(operands, DFmode);
}
    operand0 = operands[0];
    operand1 = operands[1];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	operand1));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:3895 */
extern rtx gen_split_379 PARAMS ((rtx *));
rtx
gen_split_379 (operands)
      rtx *operands ATTRIBUTE_UNUSED;
{
  rtx _val = 0;
  start_sequence ();
{
  if (!pic30_wreg_operand(operands[0], QImode) &&
      !pic30_wreg_operand(operands[2], QImode))
  {
  	rtx pop = gen_rtx_MEM(QImode, operands[3]);
	emit_insn(gen_movhi_address(operands[3], XEXP(operands[1],0)));
	emit_insn(gen_addqi3(operands[0], operands[2], pop));
  	DONE;
  }
  else
  {
  	FAIL;
  }
}
  emit_insn (const0_rtx);
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:4012 */
extern rtx gen_split_380 PARAMS ((rtx *));
rtx
gen_split_380 (operands)
      rtx *operands;
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx _val = 0;
  start_sequence ();
{
  if (!pic30_wreg_operand(operands[0], HImode) &&
      !pic30_wreg_operand(operands[2], HImode))
  {
  }
  else
  {
  	FAIL;
  }
}
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand3,
	operand1));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_PLUS (HImode,
	operand2,
	copy_rtx (operand3))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:4422 */
extern rtx gen_split_381 PARAMS ((rtx *));
rtx
gen_split_381 (operands)
      rtx *operands;
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx _val = 0;
  start_sequence ();
{
  if (!pic30_wreg_operand(operands[0], HImode) &&
      !pic30_wreg_operand(operands[2], HImode))
  {
  }
  else
  {
  	FAIL;
  }
}
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand3,
	operand1));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MINUS (HImode,
	copy_rtx (operand3),
	operand2)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:4667 */
rtx
gen_mulhi3 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[3];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;

{
	if (INTVAL(operands[2]) == 2)
	{
			emit_insn(gen_mulhi3imm(operands[0],
						operands[1],
						operands[2]));
	}
	else
	{
		FAIL;
	}
}
    operand0 = operands[0];
    operand1 = operands[1];
    operand2 = operands[2];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_MULT (HImode,
	operand1,
	operand2)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:6156 */
extern rtx gen_split_383 PARAMS ((rtx *));
rtx
gen_split_383 (operands)
      rtx *operands ATTRIBUTE_UNUSED;
{
  rtx _val = 0;
  start_sequence ();
{
  if (!pic30_wreg_operand(operands[0], QImode) &&
      !pic30_wreg_operand(operands[1], QImode))
  {
  	rtx pop = gen_rtx_MEM(QImode, operands[3]);
	emit_insn(gen_movhi_address(operands[3], XEXP(operands[2],0)));
	emit_insn(gen_andqi3(operands[0], operands[1], pop));
  	DONE;
  }
  else
  {
  	FAIL;
  }
}
  emit_insn (const0_rtx);
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:6271 */
extern rtx gen_split_384 PARAMS ((rtx *));
rtx
gen_split_384 (operands)
      rtx *operands;
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx _val = 0;
  start_sequence ();
{
  if (pic30_wreg_operand(operands[0], HImode) &&
      pic30_wreg_operand(operands[1], HImode))
  {
  	FAIL;
  }
}
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand3,
	operand2));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_AND (HImode,
	copy_rtx (operand3),
	operand1)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:6326 */
extern rtx gen_split_385 PARAMS ((rtx *));
rtx
gen_split_385 (operands)
      rtx *operands ATTRIBUTE_UNUSED;
{
  rtx _val = 0;
  start_sequence ();
{
  	rtx pop = gen_rtx_MEM(SImode, operands[2]);
	emit_insn(gen_movhi_address(operands[2], XEXP(operands[0],0)));
	emit_insn(gen_andsi3(pop, operands[1], pop));
	DONE;
  }
  emit_insn (const0_rtx);
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:6348 */
extern rtx gen_split_386 PARAMS ((rtx *));
rtx
gen_split_386 (operands)
      rtx *operands ATTRIBUTE_UNUSED;
{
  rtx _val = 0;
  start_sequence ();
{
  	rtx pop = gen_rtx_MEM(SImode, operands[2]);
	emit_insn(gen_movhi_address(operands[2], XEXP(operands[0],0)));
	emit_insn(gen_andsi3(pop, operands[1], pop));
	DONE;
  }
  emit_insn (const0_rtx);
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:6431 */
extern rtx gen_split_387 PARAMS ((rtx *));
rtx
gen_split_387 (operands)
      rtx *operands ATTRIBUTE_UNUSED;
{
  rtx _val = 0;
  start_sequence ();
{
  if (!pic30_wreg_operand(operands[0], QImode) &&
      !pic30_wreg_operand(operands[1], QImode))
  {
  	rtx pop = gen_rtx_MEM(QImode, operands[3]);
	emit_insn(gen_movhi_address(operands[3], XEXP(operands[2],0)));
	emit_insn(gen_iorqi3(operands[0], operands[1], pop));
  	DONE;
  }
  else
  {
  	FAIL;
  }
}
  emit_insn (const0_rtx);
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:6691 */
extern rtx gen_split_388 PARAMS ((rtx *));
rtx
gen_split_388 (operands)
      rtx *operands ATTRIBUTE_UNUSED;
{
  rtx _val = 0;
  start_sequence ();
{
  if (!pic30_wreg_operand(operands[0], QImode) &&
      !pic30_wreg_operand(operands[1], QImode))
  {
  	rtx pop = gen_rtx_MEM(QImode, operands[3]);
	emit_insn(gen_movhi_address(operands[3], XEXP(operands[2],0)));
	emit_insn(gen_xorqi3(operands[0], operands[1], pop));
  	DONE;
  }
  else
  {
  	FAIL;
  }
}
  emit_insn (const0_rtx);
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:7071 */
extern rtx gen_split_389 PARAMS ((rtx *));
rtx
gen_split_389 (operands)
      rtx *operands;
{
  rtx operand0;
  rtx operand1;
  rtx _val = 0;
  start_sequence ();
{
  if (!pic30_wreg_operand(operands[0], HImode))
  {
  }
  else
  {
  	FAIL;
  }
}
  operand0 = operands[0];
  operand1 = operands[1];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	operand1));
  emit_insn (gen_rtx_SET (VOIDmode,
	copy_rtx (operand0),
	gen_rtx_ASHIFT (HImode,
	copy_rtx (operand0),
	const1_rtx)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:7139 */
rtx
gen_ashlsi3 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[3];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;

{
	if (GET_CODE(operands[2]) == CONST_INT)
	{
		switch (INTVAL(operands[2]))
		{
		case 0:
			emit_insn(gen_movsi(operands[0], operands[1]));
			break;
		case 1:
			emit_insn(gen_ashlsi3_imm1(operands[0],
						operands[1], operands[2]));
			break;
		case 8:
			emit_insn(gen_ashlsi3_imm8(operands[0],
						operands[1], operands[2]));
			break;
		case 2 ... 7:
		case 9 ... 15:
			emit_insn(gen_ashlsi3_imm2to15(operands[0],
						operands[1], operands[2]));
			break;
		case 16:
			emit_insn(gen_ashlsi3_imm16plus(operands[0],
						operands[1], operands[2]));
			break;
		case 17 ... 31:
			emit_insn(gen_ashlsi3_imm16plus(operands[0],
						operands[1], operands[2]));
			break;
		default:
			emit_insn(gen_movsi(operands[0], const0_rtx));
			break;
		}
	}
	else
	{
		emit_insn(gen_ashlsi3_reg(operands[0],operands[1],operands[2]));
	}
	DONE;
}
    operand0 = operands[0];
    operand1 = operands[1];
    operand2 = operands[2];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFT (SImode,
	operand1,
	operand2)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:7319 */
rtx
gen_ashldi3 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[3];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;

{
	if (GET_CODE(operands[2]) == CONST_INT)
	{
		switch (INTVAL(operands[2]))
		{
		case 0:
			emit_insn(gen_movdi(operands[0], operands[1]));
			break;
		case 1:
			emit_insn(gen_ashldi3_imm1(operands[0],
						    operands[1], operands[2]));
			break;
		case 2 ... 15:
			emit_insn(gen_ashldi3_immn(operands[0],
						   operands[1], operands[2]));
			break;
		case 16:
			emit_insn(gen_ashldi3_imm16(operands[0],
						    operands[1], operands[2]));
			break;
		case 17 ... 31:
			emit_insn(gen_ashldi3_immn(operands[0],
						   operands[1], operands[2]));
			break;
		case 32:
			emit_insn(gen_ashldi3_imm32(operands[0],
						    operands[1], operands[2]));
			break;
		case 33 ... 47:
			emit_insn(gen_ashldi3_immn(operands[0],
						   operands[1], operands[2]));
			break;
		case 48:
			emit_insn(gen_ashldi3_imm48(operands[0],
						    operands[1], operands[2]));
			break;
		case 49 ... 63:
			emit_insn(gen_ashldi3_immn(operands[0],
						   operands[1], operands[2]));
			break;
		default:
			emit_insn(gen_movdi(operands[0], const0_rtx));
			break;
		}
	}
	else
	{
		emit_insn(gen_ashldi3_reg(operands[0],operands[1],operands[2]));
	}
	DONE;
}
    operand0 = operands[0];
    operand1 = operands[1];
    operand2 = operands[2];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFT (DImode,
	operand1,
	operand2)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:7579 */
rtx
gen_lshrsi3 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[3];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;

{
	if (GET_CODE(operands[2]) == CONST_INT)
	{
		switch (INTVAL(operands[2]))
		{
		case 0:
			emit_insn(gen_movsi(operands[0], operands[1]));
			break;
		case 1:
			emit_insn(gen_lshrsi3_imm1(operands[0],
						operands[1], operands[2]));
			break;
		case 2 ... 15:
			emit_insn(gen_lshrsi3_imm2to15(operands[0],
						operands[1], operands[2]));
			break;
		case 16:
			emit_insn(gen_lshrsi3_imm16plus(operands[0],
						operands[1], operands[2]));
			break;
		case 17 ... 31:
			emit_insn(gen_lshrsi3_imm16plus(operands[0],
						operands[1], operands[2]));
			break;
		default:
			emit_insn(gen_movsi(operands[0], const0_rtx));
			break;
		}
	}
	else
	{
		emit_insn(gen_lshrsi3_reg(operands[0],operands[1],operands[2]));
	}
	DONE;
}
    operand0 = operands[0];
    operand1 = operands[1];
    operand2 = operands[2];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_LSHIFTRT (SImode,
	operand1,
	operand2)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:7708 */
rtx
gen_lshrdi3 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[3];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;

{
	if (GET_CODE(operands[2]) == CONST_INT)
	{
		switch (INTVAL(operands[2]))
		{
		case 0:
			emit_insn(gen_movdi(operands[0], operands[1]));
			break;
		case 1:
			emit_insn(gen_lshrdi3_imm1(operands[0],
						    operands[1], operands[2]));
			break;
		case 2 ... 15:
			emit_insn(gen_lshrdi3_immn(operands[0],
						   operands[1], operands[2]));
			break;
		case 16:
			emit_insn(gen_lshrdi3_imm16(operands[0],
						    operands[1], operands[2]));
			break;
		case 17 ... 31:
			emit_insn(gen_lshrdi3_immn(operands[0],
						   operands[1], operands[2]));
			break;
		case 32:
			emit_insn(gen_lshrdi3_imm32(operands[0],
						    operands[1], operands[2]));
			break;
		case 33 ... 47:
			emit_insn(gen_lshrdi3_immn(operands[0],
						   operands[1], operands[2]));
			break;
		case 48:
			emit_insn(gen_lshrdi3_imm48(operands[0],
						    operands[1], operands[2]));
			break;
		case 49 ... 63:
			emit_insn(gen_lshrdi3_immn(operands[0],
						   operands[1], operands[2]));
			break;
		default:
			emit_insn(gen_movdi(operands[0], const0_rtx));
			break;
		}
	}
	else
	{
		emit_insn(gen_lshrdi3_reg(operands[0],operands[1],operands[2]));
	}
	DONE;
}
    operand0 = operands[0];
    operand1 = operands[1];
    operand2 = operands[2];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_LSHIFTRT (DImode,
	operand1,
	operand2)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:7963 */
rtx
gen_ashrsi3 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[3];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;

{
	if (GET_CODE(operands[2]) == CONST_INT)
	{
		switch (INTVAL(operands[2]))
		{
		case 0:
			emit_insn(gen_movsi(operands[0], operands[1]));
			break;
		case 1:
			emit_insn(gen_ashrsi3_imm1(operands[0],
						operands[1], operands[2]));
			break;
		case 2 ... 15:
			emit_insn(gen_ashrsi3_imm2to15(operands[0],
						operands[1], operands[2]));
			break;
		case 16:
			emit_insn(gen_ashrsi3_imm16plus(operands[0],
						operands[1], operands[2]));
			break;
		case 17 ... 31:
			emit_insn(gen_ashrsi3_imm16plus(operands[0],
						operands[1], operands[2]));
			break;
		default:
			emit_insn(gen_movsi(operands[0], const0_rtx));
			break;
		}
	}
	else
	{
		emit_insn(gen_ashrsi3_reg(operands[0],operands[1],operands[2]));
	}
	DONE;
}
    operand0 = operands[0];
    operand1 = operands[1];
    operand2 = operands[2];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFTRT (SImode,
	operand1,
	operand2)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:8091 */
rtx
gen_ashrdi3 (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[3];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;

{
	if (GET_CODE(operands[2]) == CONST_INT)
	{
		switch (INTVAL(operands[2]))
		{
		case 0:
			emit_insn(gen_movdi(operands[0], operands[1]));
			break;
		case 1:
			emit_insn(gen_ashrdi3_imm1(operands[0],
						    operands[1], operands[2]));
			break;
		case 2 ... 15:
			emit_insn(gen_ashrdi3_immn(operands[0],
						   operands[1], operands[2]));
			break;
		case 16:
			emit_insn(gen_ashrdi3_imm16(operands[0],
						    operands[1], operands[2]));
			break;
		case 17 ... 31:
			emit_insn(gen_ashrdi3_immn(operands[0],
						   operands[1], operands[2]));
			break;
		case 32:
			emit_insn(gen_ashrdi3_imm32(operands[0],
						    operands[1], operands[2]));
			break;
		case 33 ... 47:
			emit_insn(gen_ashrdi3_immn(operands[0],
						   operands[1], operands[2]));
			break;
		case 48:
			emit_insn(gen_ashrdi3_imm48(operands[0],
						    operands[1], operands[2]));
			break;
		case 49 ... 63:
			emit_insn(gen_ashrdi3_immn(operands[0],
						   operands[1], operands[2]));
			break;
		default:
			emit_insn(gen_movdi(operands[0], const0_rtx));
			break;
		}
	}
	else
	{
		emit_insn(gen_ashrdi3_reg(operands[0],operands[1],operands[2]));
	}
	DONE;
}
    operand0 = operands[0];
    operand1 = operands[1];
    operand2 = operands[2];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_ASHIFTRT (DImode,
	operand1,
	operand2)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:8402 */
rtx
gen_insv (operand0, operand1, operand2, operand3)
     rtx operand0;
     rtx operand1;
     rtx operand2;
     rtx operand3;
{
  rtx operand4 ATTRIBUTE_UNUSED;
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[5];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;
    operands[3] = operand3;

{
  if ((INTVAL(operands[1]) == 1) && (GET_CODE(operands[3]) == CONST_INT) &&
      /* pic30_reg_or_near_operand is already called, but if optimization is
         on, constant addresses are forced into a register so that 'cse can
         get a chance to see them' (in fn memory_address)... thats okay, cse 
         will turn them back to constants we hope */
      (pic30_reg_or_near_operand(operands[0],VOIDmode)))
  {  int mask;
     rtx mask_rtx;
  
     /* actually operand [3] does not necessarily fit into our bitfield...
        *SIGH* */
     mask = 1 << (1 - 1);  /* == 1, :) but if we can ever support larger 
                             bitfields, this won't seem so crazy */
     if ((INTVAL(operands[3]) & mask) == 0) {
        if (REG_P(operands[0]) || (GET_CODE(operands[0]) == SUBREG)) {
          mask =  ~(1 << INTVAL(operands[2]));
          mask_rtx = gen_rtx_CONST_INT(HImode, mask);
          emit(gen_bitclrhi(operands[0], operands[0], mask_rtx));
        } else if (INTVAL(operands[2]) < 8) {
          mask =  ~(1 << INTVAL(operands[2]));
          mask_rtx = gen_rtx_CONST_INT(QImode, mask);
          emit(gen_bitclrqi_sfr(operands[0], mask_rtx));
        } else {
          mask =  ~(1 << (INTVAL(operands[2]) - 8));
          mask_rtx = gen_rtx_CONST_INT(QImode, mask);
          emit(gen_addhi3(operands[4], operands[0], const1_rtx));
          emit(gen_bitclrqi(operands[0], operands[4], mask_rtx));
        }
     } else {
        if (REG_P(operands[0]) || (GET_CODE(operands[0]) == SUBREG)) {
          mask =  (1 << INTVAL(operands[2]));
          mask_rtx = gen_rtx_CONST_INT(HImode, mask);
          emit(gen_bitsethi(operands[0], operands[0], mask_rtx));
        } else if (INTVAL(operands[2]) < 8) {
          mask =  (1 << INTVAL(operands[2]));
          mask_rtx = gen_rtx_CONST_INT(QImode, mask);
          emit(gen_bitsetqi_sfr(operands[0], mask_rtx));
        } else {
          mask =  (1 << (INTVAL(operands[2]) - 8));
          mask_rtx = gen_rtx_CONST_INT(QImode, mask);
          emit(gen_addhi3(operands[4], operands[0], const1_rtx));
          emit(gen_bitsetqi(operands[0], operands[4], mask_rtx));
        }
     }
     DONE;
  } else  {
    FAIL;
  }  

}

    operand0 = operands[0];
    operand1 = operands[1];
    operand2 = operands[2];
    operand3 = operands[3];
    operand4 = operands[4];
  }
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_ZERO_EXTRACT (HImode,
	operand0,
	operand1,
	operand2),
	operand3));
  emit_insn (gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:8645 */
rtx
gen_casesi (operand0, operand1, operand2, operand3, operand4)
     rtx operand0;
     rtx operand1;
     rtx operand2;
     rtx operand3;
     rtx operand4;
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[5];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;
    operands[3] = operand3;
    operands[4] = operand4;

{
	if (operands[1] != const0_rtx)
	{
		rtx reg = gen_reg_rtx(SImode);

		operands[1] = GEN_INT(-INTVAL(operands[1]));
		operands[1] = force_reg(SImode, operands[1]);
		emit_insn(gen_addsi3(reg, operands[0], operands[1]));
		operands[0] = reg;
	}
	operands[2] = force_reg(SImode, operands[2]);
	emit_insn(gen_cmpsi(operands[0], operands[2]));
	emit_jump_insn(gen_bgtu(operands[4]));
	emit_jump_insn(gen_casesi0(operands[0], operands[3]));
	DONE;
}
    operand0 = operands[0];
    operand1 = operands[1];
    operand2 = operands[2];
    operand3 = operands[3];
    operand4 = operands[4];
  }
  emit (operand0);
  emit (operand1);
  emit (operand2);
  emit (operand3);
  emit (operand4);
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:8717 */
rtx
gen_call_value (operand0, operand1, operand2)
     rtx operand0;
     rtx operand1;
     rtx operand2;
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[3];
    operands[0] = operand0;
    operands[1] = operand1;
    operands[2] = operand2;

{  
     emit(gen_call_value_helper(operands[0], operands[1], operands[2]));
     DONE;
}
  
    operand0 = operands[0];
    operand1 = operands[1];
    operand2 = operands[2];
  }
  emit_call_insn (gen_rtx_SET (VOIDmode,
	operand0,
	gen_rtx_CALL (VOIDmode,
	operand1,
	operand2)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:8795 */
rtx
gen_call (operand0, operand1)
     rtx operand0;
     rtx operand1;
{
  rtx _val = 0;
  start_sequence ();
  {
    rtx operands[2];
    operands[0] = operand0;
    operands[1] = operand1;

{
  if (GET_CODE (operands[0]) == MEM
      && ! pic30_call_address_operand (XEXP (operands[0], 0), Pmode))
    operands[0] = gen_rtx_MEM (GET_MODE (operands[0]),
			       force_reg (Pmode, XEXP (operands[0], 0)));
}
    operand0 = operands[0];
    operand1 = operands[1];
  }
  emit_call_insn (gen_rtx_CALL (VOIDmode,
	operand0,
	operand1));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:8896 */
rtx
gen_prologue ()
{
  rtx _val = 0;
  start_sequence ();
  {

  {
  	pic30_expand_prologue();
	DONE;
  }
  }
  emit_insn (const1_rtx);
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:8906 */
rtx
gen_epilogue ()
{
  rtx _val = 0;
  start_sequence ();
  {

  {
  	pic30_expand_epilogue();
	DONE;
  }
  }
  emit_insn (const1_rtx);
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:9013 */
extern rtx gen_peephole2_404 PARAMS ((rtx, rtx *));
rtx
gen_peephole2_404 (curr_insn, operands)
     rtx curr_insn ATTRIBUTE_UNUSED;
     rtx *operands;
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  start_sequence ();

  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand3,
	gen_rtx_SUBREG (HImode,
	operand1,
	2)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:9031 */
extern rtx gen_peephole2_405 PARAMS ((rtx, rtx *));
rtx
gen_peephole2_405 (curr_insn, operands)
     rtx curr_insn ATTRIBUTE_UNUSED;
     rtx *operands;
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx operand4;
  rtx operand5;
  rtx operand6;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  start_sequence ();

  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  operand4 = operands[4];
  operand5 = operands[5];
  operand6 = operands[6];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand4,
	gen_rtx_SUBREG (HImode,
	operand1,
	2)));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand3,
	gen_rtx (GET_CODE (operand6), GET_MODE (operand6),
		copy_rtx (operand4),
		operand5)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:9054 */
extern rtx gen_peephole2_406 PARAMS ((rtx, rtx *));
rtx
gen_peephole2_406 (curr_insn, operands)
     rtx curr_insn ATTRIBUTE_UNUSED;
     rtx *operands;
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  start_sequence ();

  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand3,
	gen_rtx_SUBREG (HImode,
	operand1,
	2)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:9072 */
extern rtx gen_peephole2_407 PARAMS ((rtx, rtx *));
rtx
gen_peephole2_407 (curr_insn, operands)
     rtx curr_insn ATTRIBUTE_UNUSED;
     rtx *operands;
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx operand4;
  rtx operand5;
  rtx operand6;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  start_sequence ();

  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  operand4 = operands[4];
  operand5 = operands[5];
  operand6 = operands[6];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand4,
	gen_rtx_SUBREG (HImode,
	operand1,
	2)));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand3,
	gen_rtx (GET_CODE (operand6), GET_MODE (operand6),
		copy_rtx (operand4),
		operand5)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:9119 */
extern rtx gen_peephole2_410 PARAMS ((rtx, rtx *));
rtx
gen_peephole2_410 (curr_insn, operands)
     rtx curr_insn ATTRIBUTE_UNUSED;
     rtx *operands;
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  start_sequence ();
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand3,
	gen_rtx_MEM (HImode,
	gen_rtx_PLUS (HImode,
	operand1,
	operand2))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:9505 */
extern rtx gen_peephole2_427 PARAMS ((rtx, rtx *));
rtx
gen_peephole2_427 (curr_insn, operands)
     rtx curr_insn ATTRIBUTE_UNUSED;
     rtx *operands;
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  start_sequence ();

  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_SUBREG (HImode,
	operand2,
	0),
	gen_rtx_ASHIFT (HImode,
	operand1,
	const1_rtx)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:9518 */
extern rtx gen_peephole2_428 PARAMS ((rtx, rtx *));
rtx
gen_peephole2_428 (curr_insn, operands)
     rtx curr_insn ATTRIBUTE_UNUSED;
     rtx *operands;
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  start_sequence ();

  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_SUBREG (HImode,
	operand2,
	0),
	gen_rtx_ASHIFT (HImode,
	operand1,
	const1_rtx)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:9534 */
extern rtx gen_peephole2_429 PARAMS ((rtx, rtx *));
rtx
gen_peephole2_429 (curr_insn, operands)
     rtx curr_insn ATTRIBUTE_UNUSED;
     rtx *operands;
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx operand4;
  rtx operand5;
  rtx operand6;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  if ((operands[5] = peep2_find_free_register (0, 0, "a", HImode, &_regs_allocated)) == NULL_RTX)
    return NULL;
  start_sequence ();

  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  operand4 = operands[4];
  operand5 = operands[5];
  operand6 = operands[6];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand5,
	gen_rtx_ASHIFT (HImode,
	operand1,
	const1_rtx)));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand6,
	gen_rtx_PLUS (HImode,
	operand4,
	copy_rtx (operand5))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:9553 */
extern rtx gen_peephole2_430 PARAMS ((rtx, rtx *));
rtx
gen_peephole2_430 (curr_insn, operands)
     rtx curr_insn ATTRIBUTE_UNUSED;
     rtx *operands;
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx operand4;
  rtx operand5;
  rtx operand6;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  if ((operands[5] = peep2_find_free_register (0, 0, "a", HImode, &_regs_allocated)) == NULL_RTX)
    return NULL;
  start_sequence ();

  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  operand4 = operands[4];
  operand5 = operands[5];
  operand6 = operands[6];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand5,
	gen_rtx_ASHIFT (HImode,
	operand1,
	const1_rtx)));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand6,
	gen_rtx_PLUS (HImode,
	operand4,
	copy_rtx (operand5))));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:9756 */
extern rtx gen_peephole2_445 PARAMS ((rtx, rtx *));
rtx
gen_peephole2_445 (curr_insn, operands)
     rtx curr_insn ATTRIBUTE_UNUSED;
     rtx *operands;
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  start_sequence ();

  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand2,
	const0_rtx));
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_SUBREG (QImode,
	copy_rtx (operand2),
	0),
	constm1_rtx));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:9769 */
extern rtx gen_peephole2_446 PARAMS ((rtx, rtx *));
rtx
gen_peephole2_446 (curr_insn, operands)
     rtx curr_insn ATTRIBUTE_UNUSED;
     rtx *operands;
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  start_sequence ();

  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand2,
	const0_rtx));
  emit_insn (gen_rtx_SET (VOIDmode,
	gen_rtx_SUBREG (QImode,
	copy_rtx (operand2),
	1),
	constm1_rtx));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:9785 */
extern rtx gen_peephole2_447 PARAMS ((rtx, rtx *));
rtx
gen_peephole2_447 (curr_insn, operands)
     rtx curr_insn ATTRIBUTE_UNUSED;
     rtx *operands;
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  start_sequence ();
{ operands[1] = gen_rtx_CONST_INT(HImode,-INTVAL(operands[1])); }
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand2,
	gen_rtx_MINUS (HImode,
	copy_rtx (operand2),
	operand1)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:9797 */
extern rtx gen_peephole2_448 PARAMS ((rtx, rtx *));
rtx
gen_peephole2_448 (curr_insn, operands)
     rtx curr_insn ATTRIBUTE_UNUSED;
     rtx *operands;
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  start_sequence ();
{ operands[1] = gen_rtx_CONST_INT(HImode,-INTVAL(operands[1])); }
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand2,
	gen_rtx_MINUS (HImode,
	operand3,
	operand1)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:9813 */
extern rtx gen_peephole2_449 PARAMS ((rtx, rtx *));
rtx
gen_peephole2_449 (curr_insn, operands)
     rtx curr_insn ATTRIBUTE_UNUSED;
     rtx *operands;
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx operand4;
  rtx operand5;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  start_sequence ();
{ int reg = REGNO(operands[5]);
    operands[5] = gen_rtx_REG(HImode,reg);
    operands[0] = gen_rtx_REG(HImode,reg+1); }
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  operand4 = operands[4];
  operand5 = operands[5];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand5,
	operand4));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	operand1));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:9834 */
extern rtx gen_peephole2_450 PARAMS ((rtx, rtx *));
rtx
gen_peephole2_450 (curr_insn, operands)
     rtx curr_insn ATTRIBUTE_UNUSED;
     rtx *operands;
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx operand4;
  rtx operand5;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  start_sequence ();
{ int reg = REGNO(operands[5]);
    operands[5] = gen_rtx_REG(HImode,reg+1);
    operands[0] = gen_rtx_REG(HImode,reg); }
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  operand4 = operands[4];
  operand5 = operands[5];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand5,
	operand1));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	operand4));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:9852 */
extern rtx gen_peephole2_451 PARAMS ((rtx, rtx *));
rtx
gen_peephole2_451 (curr_insn, operands)
     rtx curr_insn ATTRIBUTE_UNUSED;
     rtx *operands;
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx operand3;
  rtx operand4;
  rtx operand5;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  start_sequence ();
{ int reg = REGNO(operands[0]);
    operands[2] = gen_rtx_REG(HImode, reg+1);
    operands[3] = gen_rtx_REG(HImode, reg);  }
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  operand3 = operands[3];
  operand4 = operands[4];
  operand5 = operands[5];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand2,
	operand1));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand3,
	operand4));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand5,
	operand0));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:9873 */
extern rtx gen_peephole2_452 PARAMS ((rtx, rtx *));
rtx
gen_peephole2_452 (curr_insn, operands)
     rtx curr_insn ATTRIBUTE_UNUSED;
     rtx *operands;
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  start_sequence ();
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand2,
	operand1));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:9882 */
extern rtx gen_peephole2_453 PARAMS ((rtx, rtx *));
rtx
gen_peephole2_453 (curr_insn, operands)
     rtx curr_insn ATTRIBUTE_UNUSED;
     rtx *operands;
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  start_sequence ();
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand2,
	operand1));
  _val = get_insns ();
  end_sequence ();
  return _val;
}

/* ./config/pic30/pic30.md:9891 */
extern rtx gen_peephole2_454 PARAMS ((rtx, rtx *));
rtx
gen_peephole2_454 (curr_insn, operands)
     rtx curr_insn ATTRIBUTE_UNUSED;
     rtx *operands;
{
  rtx operand0;
  rtx operand1;
  rtx operand2;
  rtx _val = 0;
  HARD_REG_SET _regs_allocated;
  CLEAR_HARD_REG_SET (_regs_allocated);
  start_sequence ();
  operand0 = operands[0];
  operand1 = operands[1];
  operand2 = operands[2];
  emit_insn (gen_rtx_SET (VOIDmode,
	operand0,
	operand1));
  emit_insn (gen_rtx_SET (VOIDmode,
	operand2,
	copy_rtx (operand1)));
  _val = get_insns ();
  end_sequence ();
  return _val;
}



void
add_clobbers (pattern, insn_code_number)
     rtx pattern ATTRIBUTE_UNUSED;
     int insn_code_number;
{
  switch (insn_code_number)
    {
    case 361:
      XVECEXP (pattern, 0, 1) = gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_REG (HImode,
	14));
      break;

    case 193:
    case 192:
    case 191:
    case 190:
    case 189:
    case 188:
      XVECEXP (pattern, 0, 2) = gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_REG (HImode,
	16));
      break;

    case 187:
    case 186:
      XVECEXP (pattern, 0, 1) = gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_REG (HImode,
	16));
      break;

    case 161:
      XVECEXP (pattern, 0, 1) = gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (QImode));
      break;

    case 331:
    case 330:
    case 325:
    case 323:
    case 316:
    case 315:
    case 310:
    case 309:
    case 299:
    case 298:
    case 293:
    case 292:
    case 265:
    case 261:
    case 260:
    case 255:
    case 254:
    case 252:
    case 251:
    case 250:
    case 246:
    case 245:
    case 243:
    case 242:
    case 241:
    case 236:
    case 165:
    case 148:
    case 143:
    case 132:
    case 123:
    case 71:
    case 63:
    case 62:
      XVECEXP (pattern, 0, 1) = gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_SCRATCH (HImode));
      break;

    case 60:
      XVECEXP (pattern, 0, 4) = gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_REG (HImode,
	16));
      break;

    case 59:
      XVECEXP (pattern, 0, 5) = gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_REG (HImode,
	16));
      break;

    case 45:
      XVECEXP (pattern, 0, 1) = gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_REG (HImode,
	0));
      XVECEXP (pattern, 0, 2) = gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_REG (HImode,
	1));
      XVECEXP (pattern, 0, 3) = gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_REG (HImode,
	2));
      XVECEXP (pattern, 0, 4) = gen_rtx_CLOBBER (VOIDmode,
	gen_rtx_REG (HImode,
	3));
      break;

    default:
      abort ();
    }
}


int
added_clobbers_hard_reg_p (insn_code_number)
     int insn_code_number;
{
  switch (insn_code_number)
    {
    case 161:
    case 331:
    case 330:
    case 325:
    case 323:
    case 316:
    case 315:
    case 310:
    case 309:
    case 299:
    case 298:
    case 293:
    case 292:
    case 265:
    case 261:
    case 260:
    case 255:
    case 254:
    case 252:
    case 251:
    case 250:
    case 246:
    case 245:
    case 243:
    case 242:
    case 241:
    case 236:
    case 165:
    case 148:
    case 143:
    case 132:
    case 123:
    case 71:
    case 63:
    case 62:
      return 0;

    case 361:
    case 193:
    case 192:
    case 191:
    case 190:
    case 189:
    case 188:
    case 187:
    case 186:
    case 60:
    case 59:
    case 45:
      return 1;

    default:
      abort ();
    }
}
